#ifndef _SolidHalfBoundingBox_H__
#define _SolidHalfBoundingBox_H__

#include "OgrePrerequisites.h"

#include "OgreWireBoundingBox.h"

namespace Ogre {

    /** Allows the rendering of one half of a solid bounding box.
        @remarks
            This class builds a wireframe renderable from a given aabb. A pointer to this class can be
			added to a render queue to display the bounding box of an object.
    */
	class SolidHalfBoundingBox : public WireBoundingBox
	{
    protected:
       
        /** Builds the wireframe line list.
        */
		void setupBoundingBoxVertices(const AxisAlignedBox& aab);
		
	public:
		
		bool mIsFirstHalf;
		void setupBoundingBox(const AxisAlignedBox& aabb);
		SolidHalfBoundingBox(bool isFirstHalf);
	};

}// namespace

#endif


