#include "OgreOcclusionCullingSceneManager.h"
#include "OgreMath.h"
#include "OgreIteratorWrappers.h"
#include "OgreRenderSystem.h"
#include "OgreCamera.h"
#include "OgreHardwareOcclusionQuery.h"
//#include "OgreWireBoundingBox.h"
#include "OgreSolidHalfBoundingBox.h"

#include <windows.h>

namespace Ogre {
	
	//-----------------------------------------------------------------------
	OcclusionCullingSceneManager::OcclusionCullingSceneManager()
	{
	}
	//-----------------------------------------------------------------------
	void OcclusionCullingSceneManager::_findVisibleObjects( Camera* cam, bool onlyShadowCasters )
	{
		// empty because we have to find objects in _renderVisibleObjects
	}
	//-----------------------------------------------------------------------
	void OcclusionCullingSceneManager::_renderVisibleObjects( void )
	{
		mSceneTraverser.renderScene(mCameraInProgress, mSceneRoot);
	}
	//-----------------------------------------------------------------------
	/*void OcclusionCullingSceneManager::renderZPass()
	{
		traverseNode(mSceneRoot);
	}*/
	//-----------------------------------------------------------------------
	void OcclusionCullingSceneManager::_updateSceneGraph( Camera* cam )
	{
		mSceneTraverser.preprocess();
		
		SceneManager::_updateSceneGraph(cam);
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingSceneManager::setOption( const String & key, const void * val )
	{
		mSceneTraverser.setOption(key, val);
			
		return SceneManager::setOption( key, val );
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingSceneManager::getOption( const String & key, void *val )
	{
		mSceneTraverser.getOption(key, val);
		
		return SceneManager::getOption( key, val );
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingSceneManager::getOptionValues( const String & key, StringVector  &refValueList )
	{
		return SceneManager::getOptionValues( key, refValueList );
	}
	//-----------------------------------------------------------------------
	bool OcclusionCullingSceneManager::getOptionKeys( StringVector & refKeys )
	{
		SceneManager::getOptionKeys( refKeys );

		refKeys.push_back( "Algorithm" );
		refKeys.push_back( "Threshold" );
		refKeys.push_back( "NumSceneNodes" );
		refKeys.push_back( "NumTraversedNodes" );
		refKeys.push_back( "NumQueryCulledNodes" );
		refKeys.push_back( "NumFrustumCulledNodes" );
		//refKeys.push_back( "mNumRenderedGeometry" );
		return true;
	}
}	
