/*
-----------------------------------------------------------------------------
This source file is part of OGRE
    (Object-oriented Graphics Rendering Engine)
For the latest info, see http://www.ogre3d.org/

Copyright  2000-2002 The OGRE Team
Also see acknowledgements in Readme.html

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

//#include "OgreOcclusionCullingSceneManager.h"
//#include "OgreTerrainOcclusionCullingSceneManager.h"
#include <OgreOctreeSceneManager.h>
#include <OgreTerrainSceneManager.h>
#include <OgreRoot.h>
#include "OgreHeightmapTerrainPageSource.h"
//#include <windows.h>

namespace Ogre {

    //OcclusionCullingSceneManager *occlusionPlugin;
	//TerrainOcclusionCullingSceneManager *terrainOcclusionPlugin;
	OctreeSceneManager *ocPlugin;

    //-----------------------------------------------------------------------
    extern "C" void dllStartPlugin(void)
    {
		// Create new scene manager
	//	occlusionPlugin = new OcclusionCullingSceneManager();
		ocPlugin = new OctreeSceneManager();
    
	    // Register
		//Root::getSingleton().setSceneManager( ST_GENERIC, occlusionPlugin );
//		Root::getSingleton().setSceneManager( ST_EXTERIOR_CLOSE, terrainOcclusionPlugin );
		Root::getSingleton().setSceneManager( ST_EXTERIOR_CLOSE, ocPlugin );

		//MessageBox( NULL, "myplugin registered", "this is my plugin", MB_OK | MB_ICONERROR | MB_TASKMODAL);
    }
    extern "C" void dllStopPlugin(void)
    {
      //  delete occlusionPlugin;
		delete ocPlugin;
		//delete terrainOcclusionPlugin;
    }
}
